package black_jack;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.util.concurrent.TimeUnit;

import handlers.MouseHandler;
import main.Chip;
import main.Controller;
import main.Frame;
import main.GameBoard;
import main.ImageLoader;
import universal.Cards;
import universal.Deck;

public class BlackJack {
	
	private Image board, closeGame;
	private Image clearbetButton, dealButton, splitButton, surrenderButton, hitButton, 
		standButton, repeatbetButton, insuranceButton, doubledownButton;
	public Rectangle[] buttons = {
			new Rectangle(1250, 5, 25, 25), new Rectangle(575, 500, 128, 64),  //close game, deal
			new Rectangle(150, 525, 128, 64), new Rectangle(400, 630, 128, 64), //clear, hit,
			new Rectangle(550, 630, 128, 64), new Rectangle(700, 630, 128, 64), //stand, double down
			new Rectangle(850, 630, 128, 64), new Rectangle(1000, 630, 128, 64), //surrender, split
			new Rectangle(1150, 630, 128, 64)};	//insurance
	public GameBoard[] hitbox = new GameBoard[15];//26
	private Chip[] chips;
	private double money = 100;
	private double lastMoneyEarned = 0;
	int playerBet = 0;
	boolean inGame = false;
	public Cards[] cards;
	public Deck deck;
	public Cards[] dealerHand;
	
	private int playerPoints = 0;
	private String playerDisplay = "";
	private String dealerDisplay = "";
	private int dealerPoints = 0;
	boolean playerWins = true;
	boolean push = false;
	boolean playersTurn = true;
	boolean dealerDone = false;
	boolean surrendered = false;
	boolean insurance = false;
	
	public BlackJack() {
		board = new ImageLoader(ImageLoader.blackjackTable).getImage();
		hitButton = new ImageLoader(ImageLoader.hitButton).getImage();
		closeGame = new ImageLoader(ImageLoader.closeGame).getImage();
		dealButton = new ImageLoader(ImageLoader.dealButton).getImage();
		clearbetButton = new ImageLoader(ImageLoader.clearbetButton).getImage();
		standButton = new ImageLoader(ImageLoader.standButton).getImage();
		splitButton = new ImageLoader(ImageLoader.standButton).getImage();
		surrenderButton = new ImageLoader(ImageLoader.surrenderButton).getImage();
		doubledownButton = new ImageLoader(ImageLoader.doubledownButton).getImage();
		standButton = new ImageLoader(ImageLoader.standButton).getImage();
		repeatbetButton = new ImageLoader(ImageLoader.repeatbetButton).getImage();
		insuranceButton = new ImageLoader(ImageLoader.insuranceButton).getImage();
		init();
	}
	
	public void init() {
//		addHitboxes();
		dealerHand = new Cards[10];
		cards = new Cards[10];
		deck = new Deck();
		addChips();
	}
	
	public void tick() {
		for(int i = 0; i < buttons.length; i++) {
			if(buttons[i].contains(Controller.mousePoint) && MouseHandler.MOUSEDOWN) {
				if(i == 0) {
					//Close Game
					Controller.switchStates(Controller.STATE.MENU);
				}
				if(i == 1 && !inGame) {
					//DEAL Bet				
					inGame = true;
					getHand();
				}
				if(i == 2) {
					//Clear Bet
					money += playerBet;
					playerBet = 0;
				}
				if(i == 3 && playerPoints < 21 && playersTurn) {
					//HIT Bet
					addCards(cards);
				}
				if(i == 3 && dealerDone) {
					//Repeat Bet
					if(money - playerBet >= 0) {
						money -= playerBet;
					}else {
						playerBet = 0;
					}
					resetGame();
					
				}
				if(i == 4 && playerPoints < 21 && playersTurn) {
					playersTurn = false;
				}
				if(i == 5 && cards != null && cards[2] == null && money-playerBet >= 0) {
					//double down
					playerBet *= 2;
					addCards(cards);
					playersTurn = false;
				}
				if(i == 6 && cards != null && cards[2] == null && money-playerBet >= 0) {
					//surrender
					money += playerBet/2;
					playerBet = playerBet/2;
					playersTurn = false;
					surrendered = true;
				}
				if(i == 7 && dealerHand != null && dealerHand[0] != null && dealerHand[0].number == 1 
						&& !insurance && money >= playerBet/2){
					insurance = true;
				}
				MouseHandler.MOUSEDOWN = false;
			}
		}
		for(int i = 0; i < chips.length; i++) {
			if(chips[i].bounds.contains(Controller.mousePoint) && MouseHandler.MOUSEDOWN) {
				if(money >= chips[i].value) {
					money -= chips[i].value;
					playerBet += chips[i].value;
				}
				MouseHandler.MOUSEDOWN = false;
			}
		}
		if(!playersTurn) {
			if(!dealerDone) {
				done: try {
					if(!dealerDone) {
						TimeUnit.MILLISECONDS.sleep(1500);
						dealerLogic();
					}else {
						break done;
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	private void dealerLogic() {
		if(dealerPoints < 17) {
			addCards(dealerHand);
		}else {
			//Dealer stops dealing logic - see if they win
			if(dealerPoints > 21) {
				if(playerPoints <= 21) {
					playerWins = true;
					System.out.println("dealer busts: D=" + dealerPoints +", P=" + playerPoints);
					
				}
			}
			if(playerPoints < 21) {
				if(dealerPoints < playerPoints) {
					playerWins = true;
					System.out.println("O1 on P<21: D=" + dealerPoints +", P=" + playerPoints);
				}
				if(playerPoints == dealerPoints) {
					push = true;
					playerWins = false;
					System.out.println("O2 on P<21: D=" + dealerPoints +", P=" + playerPoints);
				}
				if(dealerPoints > playerPoints && dealerPoints <= 21) {
					playerWins = false;
					System.out.println("O3 on P<21: D=" + dealerPoints +", P=" + playerPoints);
				}
			}
			if(playerPoints == 21) {
				if(dealerPoints != 21) {
					playerWins = true;
					System.out.println("P is 21 and d is not: D=" + dealerPoints +", P=" + playerPoints);
				}else {
					System.out.println("p and d is 21: D=" + dealerPoints +", P=" + playerPoints);
					push = true;
					playerWins = false;
				}
			}
			if(playerPoints > 21) {
				if(dealerPoints > 21) {
					push = true;
					playerWins = false;
					System.out.println("both over 21: D=" + dealerPoints +", P=" + playerPoints);
				}
			}
			//Winnings:
			if(playerWins) {
				money += (playerBet*2);
			}
			if(!playerWins && !push) {
				money -= 0;
			}
			if(insurance && dealerHand != null && dealerHand[1] != null && dealerHand[1].number == 10) {
				//Win your money back
				money += playerBet;
				playerBet = 0;
				insurance = false;
			}
			if(insurance && dealerHand != null && dealerHand[1] != null && dealerHand[1].number != 10) {
				money -= playerBet/2;
				insurance = false;
			}
			dealerDone = true;
		}
	}
	
	private void resetGame() {
		playerPoints = 0;
		dealerPoints = 0;
		dealerDisplay = "";
		playerDisplay = "";
		cards = new Cards[10];
		dealerHand = new Cards[10];
		inGame = false;
		playersTurn = true;
		dealerDone = false;
		playerWins = false;
		push = false;
		surrendered = false;
		insurance = false;
	}
	private void addCards(Cards[] hand) {
		for(int i = 0; i < hand.length; i++) {
			if(hand[i] == null) {
				if(deck.cardsLeft <= 1) {
					deck.refreshDeck();
				}
				hand[i] = deck.pullCard();
				refreshPoints(hand);
				break;
			}
		}
	}
	
	public void refreshPoints(Cards[] hand) {
		int points = 0;
		int ace = 0;
		String display = "";
		for(int i = 0; i < hand.length; i++) {
			if(hand[i] != null) {
				points += hand[i].number;
				if(hand[i].number == 1) {
					ace = 10;
				}
			}
		}
		display = "Current Hand: " + points;
		if(ace == 10) {
			if(ace + points < 21) {
				display += " or " + (points+ace); 
			}
			if(ace + points == 21) {
				display = "21!!!!";
			}
		}
		if(points == 21) {
			display = "21!!!!";	
		}
		if(points > 21) {
			display = "Busted at: " + points;
		}
		
		if(hand == cards) {
			playerPoints = points;
			if(points+ace == 21 || points > 21) {
				playerPoints = points+ace;
				playersTurn = false;
			}
			if(points+ace <= 21) {
				playerPoints = points+ace;
			}
			playerDisplay = display;
			
		}else {
			if(points+ace <= 21) {
				dealerPoints = points+ace;
				System.out.println("Dealer Points + Ace: " + (points+ace));
			}else {
				dealerPoints = points;
			}
			dealerDisplay = display;
		}
	}

	public void render(Graphics g) {
		g.drawImage(board, 0, 0, Frame.WIDTH, Frame.HEIGHT, null);
		g.drawImage(closeGame, buttons[0].x, buttons[0].y, buttons[0].width, buttons[0].height, null);
		g.setColor(Color.WHITE);
		g.setFont(Controller.SMALL);
		g.drawString("Money: $" + ((double) Math.round(money * 100) / 100), 10, 540);
		g.drawString("Current Bet: $" + ((int)playerBet), 10, 580);
		if(lastMoneyEarned > 0) {
			g.setColor(Color.GREEN);
		}
		if(lastMoneyEarned < 0) {
			g.setColor(Color.RED);
		}
		g.drawString("Money Earned: " + ((double) Math.round(lastMoneyEarned * 100) / 100), 10, 560);
		for(int i = 0; i < chips.length; i++) {
			g.drawImage(chips[i].getImage(), chips[i].bounds.x, chips[i].bounds.y, chips[i].bounds.width, chips[i].bounds.height, null);
		}
		if(!inGame) {
			if(playerBet == 0) {
				g.setFont(Controller.NORMAL);
				g.setColor(Color.YELLOW);
				g.drawString("Please place a bet to start!", 50, 610);
			}else {
				g.drawImage(dealButton, buttons[1].x, buttons[1].y, buttons[1].width, buttons[1].height, null);
				g.drawImage(clearbetButton, buttons[2].x, buttons[2].y, buttons[2].width, buttons[2].height, null);
			}
		}else {
			if(playersTurn) {
				if(playerPoints < 21) {
					g.drawImage(hitButton, buttons[3].x, buttons[3].y, buttons[3].width, buttons[3].height, null);
					g.drawImage(standButton, buttons[4].x, buttons[4].y, buttons[4].width, buttons[4].height, null);
					if(cards != null && cards[2] == null) {
						if(money-playerBet >= 0) {
							g.drawImage(doubledownButton, buttons[5].x, buttons[5].y, buttons[5].width, buttons[5].height, null);
						}
						g.drawImage(surrenderButton, buttons[6].x, buttons[6].y, buttons[6].width, buttons[6].height, null);
					}
					if(dealerHand != null && dealerHand[0] != null && dealerHand[0].number == 1 && !insurance && money >= playerBet/2) {
						g.drawImage(insuranceButton, buttons[7].x, buttons[7].y, buttons[7].width, buttons[7].height, null);
					}
				}
			}
			for(int i = 0; i < cards.length; i++) {
				if(cards[i] != null) {
					g.drawImage(cards[i].cardImage, (Frame.WIDTH/2)-(cards[i].width/2-(i*25)), 460, (int)(cards[i].width*.85), (int)(cards[i].height*.85), null);
				}
			}
			for(int i = 0; i < dealerHand.length; i++) {
				if(dealerHand[i] != null) {
					g.drawImage(dealerHand[i].cardImage, (Frame.WIDTH/2)-(dealerHand[i].width/2-(i*25)), 40, (int)(dealerHand[i].width*.80), (int)(dealerHand[i].height*.80), null);
				}
			}
			if(dealerDone) {
				g.drawImage(repeatbetButton, buttons[3].x, buttons[3].y, buttons[3].width, buttons[3].height, null);
				g.setColor(new Color(0, 0, 0, 200));
				g.fillRoundRect(Frame.WIDTH/2-150, Frame.HEIGHT/2-150, 300, 150, 50, 50);
				g.setColor(Color.WHITE);
				g.setFont(Controller.bigFont);
				if(!surrendered) {
					if(playerWins) {
						g.drawString("You Win!", Frame.WIDTH/2-g.getFontMetrics().stringWidth("You Win!")/2, Frame.HEIGHT/2-100);
						g.drawString("Repeat Bet?", Frame.WIDTH/2-g.getFontMetrics().stringWidth("Repeat Bet?")/2, Frame.HEIGHT/2-55);
						g.setColor(Color.GREEN);
						g.drawString("Money Earned: $" + playerBet, Frame.WIDTH/2-g.getFontMetrics().stringWidth("Money Earned: $" + playerBet)/2, Frame.HEIGHT/2-25);
					}
					if(!playerWins && !push){
						g.drawString("You Lose...", Frame.WIDTH/2-g.getFontMetrics().stringWidth("You Lose...")/2, Frame.HEIGHT/2-100);
						g.drawString("Repeat Bet?", Frame.WIDTH/2-g.getFontMetrics().stringWidth("Repeat Bet?")/2, Frame.HEIGHT/2-55);
						g.setColor(Color.RED);
						g.drawString("Money Lost: $" + playerBet, Frame.WIDTH/2-g.getFontMetrics().stringWidth("Money Lost: $" + playerBet)/2, Frame.HEIGHT/2-25);
					}
					if(push) {
						g.drawString("Push! No Money Lost.", Frame.WIDTH/2-g.getFontMetrics().stringWidth("Push! No Money Lost.")/2, Frame.HEIGHT/2-100);
						g.drawString("Repeat Bet?", Frame.WIDTH/2-g.getFontMetrics().stringWidth("Repeat Bet?")/2, Frame.HEIGHT/2-55);	
						g.drawString("Money Earned: $0", Frame.WIDTH/2-g.getFontMetrics().stringWidth("Money Earned: $0")/2, Frame.HEIGHT/2-25);
					}
				}else {
					g.drawString("Surrendered. Lost Half of Bet.", Frame.WIDTH/2-g.getFontMetrics().stringWidth("Surrendered. Lost Half of Bet.")/2, Frame.HEIGHT/2-100);
					g.drawString("Repeat Bet?", Frame.WIDTH/2-g.getFontMetrics().stringWidth("Repeat Bet?")/2, Frame.HEIGHT/2-55);
					g.setColor(Color.RED);
					g.drawString("Money Lost: $" + playerBet, Frame.WIDTH/2-g.getFontMetrics().stringWidth("Money Lost: $" + playerBet)/2, Frame.HEIGHT/2-25);
				}
				g.setFont(Controller.NORMAL);
				g.setColor(Color.WHITE);
			}
		}
		g.drawString(dealerDisplay, 350, 35);
		
		if(!playerDisplay.isEmpty()) {
			g.drawString(playerDisplay, 500, 430);
		}
	}
	private void getHand() {
		deck.refreshDeck();
		playerDisplay = "";
		addCards(cards);
//		cards[0] = new Cards(Cards.cardtype.HEART, 1);
		addCards(cards);
//		addCards(dealerHand);
		dealerHand[0] = new Cards(Cards.cardtype.HEART, 1);
	}
	public void addChips() {
		chips = new Chip[5];
		int chipy = Frame.HEIGHT-90;
		int chipx = 50; 
		chips[0] = new Chip(chipx*1-25, chipy, 1, false);
		chips[1] = new Chip(chipx*2-25, chipy, 5, false);
		chips[2] = new Chip(chipx*3-25, chipy, 10, false);
		chips[3] = new Chip(chipx*4-25, chipy, 25, false);
		chips[4] = new Chip(chipx*5-25, chipy, 100, false);
	}
}
